"""Add materialization strategy and job type

Revision ID: d1a8716cf2d2
Revises: 87cf9c00ac00
Create Date: 2023-11-21 16:11:01.741721+00:00

"""
# pylint: disable=no-member, invalid-name, missing-function-docstring, unused-import, no-name-in-module

import sqlalchemy as sa
import sqlmodel

from alembic import op

# revision identifiers, used by Alembic.
revision = "d1a8716cf2d2"
down_revision = "87cf9c00ac00"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table("materialization", schema=None) as batch_op:
        batch_op.add_column(
            sa.Column(
                "strategy",
                sa.Enum(
                    "FULL",
                    "SNAPSHOT",
                    "INCREMENTAL_TIME",
                    "VIEW",
                    name="materializationstrategy",
                ),
                nullable=True,
            ),
        )
        batch_op.drop_constraint("node_revision_engine_uniq", type_="unique")
        batch_op.create_unique_constraint(
            "name_node_revision_uniq",
            ["name", "node_revision_id"],
        )
        batch_op.drop_constraint(
            "fk_materialization_engine_id_engine",
            type_="foreignkey",
        )
        batch_op.drop_column("engine_id")

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table("materialization", schema=None) as batch_op:
        batch_op.add_column(sa.Column("engine_id", sa.INTEGER(), nullable=False))
        batch_op.create_foreign_key(
            "fk_materialization_engine_id_engine",
            "engine",
            ["engine_id"],
            ["id"],
        )
        batch_op.drop_constraint("name_node_revision_uniq", type_="unique")
        batch_op.create_unique_constraint(
            "node_revision_engine_uniq",
            ["name", "node_revision_id", "engine_id"],
        )
        batch_op.drop_column("strategy")

    # ### end Alembic commands ###
